﻿#Region "File Header"
'-----------------------------------------------------------------------
' File Name         :   AddInEntry.vb
' File Description  :   1.RMS AddIn Default Function Call
'                       2.Instantiating the Items Shopping WinForm
'
' Date Created      :   8th October 2012
' Date Modified     :
'-----------------------------------------------------------------------
#End Region

#Region "Namespaces"
Imports System
#End Region

#Region "AddInEntry Class"
''' <summary>
''' Class used for AddIn Entry Function Calls
''' </summary>
''' <remarks></remarks>
Public Class AddInEntry

    Private Shared _itemsTable As DataTable

    ''' <summary>
    ''' Property to Collect DataRows and Add them to ItemsTable
    ''' </summary>
    ''' <value></value>
    ''' <remarks></remarks>
    Public Shared WriteOnly Property ItemRow() As DataRow
        Set(ByVal value As DataRow)
            _itemsTable.Rows.Add(value.ItemArray)
        End Set
    End Property

    ''' <summary>
    ''' Function Entry for RMS AddIn Calls
    ''' </summary>
    ''' <param name="session"></param>
    ''' <returns></returns>
    ''' <remarks></remarks>
    Public Function Process(ByVal session As Object) As Boolean

        'Function Call to Instantiate Item Table
        CreateItemInfoTable()

        Dim launchWinForm As New WinFormItems()
        launchWinForm.ShowDialog()

        If Not _itemsTable Is Nothing AndAlso _itemsTable.Rows.Count <> 0 Then
            For Each dr As DataRow In _itemsTable.Rows

                Dim maxTrasnEntryNumber As Integer = session.Transaction.Entries.Count + 1
                session.Transaction.CurrentEntryKey = maxTrasnEntryNumber
                session.Transaction.Entries.Add(dr("ID"), dr("ItemLookUpCode"), _
                                                           dr("QuantityPurchased"), _
                                                           dr("Quantity"), 0, dr("Price"))

                System.Windows.Forms.SendKeys.Send("~")
                System.Windows.Forms.SendKeys.Send("{TAB}")

            Next
        End If

        Return True

    End Function

    ''' <summary>
    ''' Function Instantiate a Item Datatable
    ''' </summary>
    ''' <remarks></remarks>
    Private Sub CreateItemInfoTable()
        _itemsTable = New DataTable()
        _itemsTable.Columns.Add("ID", Type.GetType("System.Int32"))
        _itemsTable.Columns.Add("ItemLookUpCode", Type.GetType("System.String"))
        _itemsTable.Columns.Add("QuantityPurchased", Type.GetType("System.Double"))
        _itemsTable.Columns.Add("Quantity", Type.GetType("System.Double"))
        _itemsTable.Columns.Add("Price", Type.GetType("System.Decimal"))
    End Sub

End Class

#End Region