﻿#Region "File Header"
'-----------------------------------------------------
' File Name         :   Marquee.vb
' File Description  :   Scrolling Text Implementaion
' Date Created      :   21st November 2012
' Date Modified     :
'-----------------------------------------------------
#End Region

#Region "Namespaces"
Imports System
Imports System.Windows.Forms
#End Region

#Region "Marquee Class"
''' <summary>
''' Class used for Scrolling Controls
''' </summary>
''' <remarks></remarks>
Public Class Marquee

#Region "Private Varibles"
    Private _scrollControl As Control
    Private _pnlCtrl As Panel
    Private _type As Type
#End Region

#Region "Properties"

    ''' <summary>
    ''' Property for Panel Control
    ''' </summary>
    ''' <value></value>
    ''' <returns></returns>
    ''' <remarks></remarks>
    Private Property PanelControl() As Panel
        Get
            Return _pnlCtrl
        End Get
        Set(ByVal value As Panel)
            _pnlCtrl = value
        End Set
    End Property

    ''' <summary>
    ''' Property for Winform Control
    ''' </summary>
    ''' <value></value>
    ''' <returns></returns>
    ''' <remarks></remarks>
    Private Property ScrControl() As Control
        Get
            Return _scrollControl
        End Get
        Set(ByVal value As Control)
            _scrollControl = value
        End Set
    End Property

    ''' <summary>
    ''' Property for Type
    ''' </summary>
    ''' <value></value>
    ''' <returns></returns>
    ''' <remarks></remarks>
    Private Property CtrlType() As Type
        Get
            Return _type
        End Get
        Set(ByVal value As Type)
            _type = value
        End Set
    End Property

#End Region

#Region "Methods"

    ''' <summary>
    ''' Function for Default Constructor
    ''' </summary>
    ''' <param name="ctrlToScroll"></param>
    ''' <remarks></remarks>
    Public Sub New(ByVal ctrlToScroll As Control)

        Me.CtrlType = ctrlToScroll.GetType()
        Me.ScrControl = ctrlToScroll

    End Sub

    ''' <summary>
    ''' Function to Scroll the Control
    ''' </summary>
    ''' <returns></returns>
    ''' <remarks></remarks>
    Public Function ScrollTheControl() As Panel

        PanelControl = New Panel()
        PanelControl.Dock = DockStyle.Fill
        Dim objTimer As New Timer()
        AddHandler objTimer.Tick, AddressOf ScrollTimer_Tick
        objTimer.Start()
        PanelControl.Controls.Add(Me.ScrControl)
        Return PanelControl

    End Function

    ''' <summary>
    ''' Functipon Handles Timer Tick Event
    ''' </summary>
    ''' <param name="sender"></param>
    ''' <param name="e"></param>
    ''' <remarks></remarks>
    Private Sub ScrollTimer_Tick(ByVal sender As Object, ByVal e As EventArgs)

        Me.ScrControl.Left = Me.ScrControl.Left - 5
        If ScrControl.Left + ScrControl.Width < 0 Then
            ScrControl.Left = PanelControl.Width
        End If

    End Sub

#End Region

End Class
#End Region