﻿#Region "File Header"
'-----------------------------------------------------------------------
' File Name         :   WinFormItems.vb
' File Description  :   1.Items Display Main Window
'                       2.Items Search Functionality
'                       3.Items Selection Functionality
'
' Date Created      :   10th October 2012
' Date Modified     :
'-----------------------------------------------------------------------
#End Region

#Region "Namespaces"
Imports System
Imports System.Windows.Forms
Imports SmartShopping.Data
Imports Microsoft.Win32
#End Region

#Region "WinFormItems Class"
''' <summary>
''' Class used to Items Display, Serach and Selective Purchase
''' </summary>
''' <remarks></remarks>
Public Class WinFormItems

    ''' <summary>
    ''' Function Handles WinForm Items Load Event
    ''' </summary>
    ''' <param name="sender"></param>
    ''' <param name="e"></param>
    ''' <remarks></remarks>
    Private Sub WinFormItems_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load

        'Setting Connection String
        'DbOperations.SetConnectionString()

        Dim registryKey As RegistryKey = Nothing

        registryKey = Registry.LocalMachine.OpenSubKey("SOFTWARE\SmartShopping", False)

        If Not registryKey Is Nothing Then

            Dim server As String = Convert.ToString(registryKey.GetValue("ServerName"))
            Dim db As String = Convert.ToString(registryKey.GetValue("DbName"))
            Dim user As String = Convert.ToString(registryKey.GetValue("UserName"))
            Dim pwd As String = Convert.ToString(registryKey.GetValue("PassWord"))

            gConnectionString = "Data Source=" & server & ";Initial Catalog=" & db & _
                        ";User ID=" & user & ";Password=" & pwd & ";"

        End If

        Dim addCustomCtrls As New AddCustomControls()

        lblFooter.Text = "Department List"
        txtSearch.Clear()
        btnBack.Visible = False
        btnHome.Visible = False
        btnAdd.Enabled = False
        pnlProgress.Visible = False
        lblQuantity.Visible = False
        nudQuantity.Visible = False

        Dim lblHeadlines As Label = addCustomCtrls.ScrollingLabelCtrl()

        Dim marqeeText As New Marquee(lblHeadlines)
        Dim pnlCtrl As Panel = marqeeText.ScrollTheControl()
        tlpHeader.SetColumnSpan(pnlCtrl, 2)
        tlpHeader.SetRowSpan(pnlCtrl, 2)
        tlpHeader.Controls.Add(pnlCtrl, 1, 1)

        addCustomCtrls.AddPanel("pnlDepartment", Me)
        'Function Call to Populate Departments
        addCustomCtrls.PopulateButtons(Nothing, Nothing)

        'Populate Search TextBox's Values
        txtSearch.AutoCompleteMode = AutoCompleteMode.SuggestAppend
        txtSearch.AutoCompleteSource = AutoCompleteSource.CustomSource
        txtSearch.AutoCompleteCustomSource = DepartmentSearchList
        txtSearch.Focus()

    End Sub

    ''' <summary>
    ''' Function Retrurns the Footer Label Text
    ''' </summary>
    ''' <returns></returns>
    ''' <remarks></remarks>
    Private Function SetFooterLabelText() As String
        Dim strLabelText As String = lblItemType.Text.Trim()
        Dim words() As String = strLabelText.Split(">")
        Return words(0).ToString()
    End Function

    '''' <summary>
    '''' Function Returns Names List
    '''' </summary>
    '''' <returns></returns>
    '''' <remarks></remarks>
    'Private Function GetItemsList() As AutoCompleteStringCollection

    '    Dim namesList As AutoCompleteStringCollection = New AutoCompleteStringCollection()
    '    Dim panel As Panel = SearchPanelCtrl()
    '    Dim tlp As TableLayoutPanel = Nothing

    '    'Searching TableLayoutPanel Contrl
    '    For Each ctrl As Control In panel.Controls
    '        tlp = ctrl
    '    Next

    '    'Iterating Dynamic Buttons and Collecting Button's Texts
    '    For Each dynButton As Control In tlp.Controls
    '        namesList.Add(dynButton.Text.Trim())
    '    Next

    '    GetItemsList = namesList

    'End Function

    ''' <summary>
    ''' Function Returns Button Name as ItemLookUpCode
    ''' </summary>
    ''' <returns></returns>
    ''' <remarks></remarks>
    Private Function GetItemButtonLookUpCode() As String

        Dim itemButtonName As String = String.Empty

        Dim pnl As Panel = SearchPanelCtrl()

        'Searching the Button Control and Selecting it using Search Box's Text
        For Each tlpCtrl As Control In pnl.Controls
            If tlpCtrl.Name = "tlpControl" Then
                For Each dynButton As Button In tlpCtrl.Controls
                    If dynButton.Focus() = True Then
                        itemButtonName = dynButton.Name
                    End If
                Next
            End If
        Next

        Return itemButtonName

    End Function

    ''' <summary>
    ''' Function Returns Required Panel
    ''' </summary>
    ''' <returns></returns>
    ''' <remarks></remarks>
    Private Function SearchPanelCtrl() As Panel

        Dim pnl As Panel = Nothing

        'Searching WinForm's Panel Control
        For Each winformCtrl As Control In Me.Controls
            For Each scCtrls As Control In winformCtrl.Controls
                For Each tlpCtrls As Control In scCtrls.Controls
                    If tlpCtrls.Name = "tlpLeft" Then
                        For Each pnlMain As Control In tlpCtrls.Controls
                            If pnlMain.Name = "pnlMain" Then
                                For Each pnlCtrls As Control In pnlMain.Controls
                                    If pnlCtrls.Name = "pnlItem" Or pnlCtrls.Name = "pnlCategory" Or pnlCtrls.Name = "pnlDepartment" Then
                                        pnl = pnlCtrls
                                    End If
                                Next
                            End If
                        Next
                    End If
                Next
            Next
        Next

        SearchPanelCtrl = pnl

    End Function

    ''' <summary>
    ''' Function Handles Search TextBox TextChange Event
    ''' </summary>
    ''' <param name="sender"></param>
    ''' <param name="e"></param>
    ''' <remarks></remarks>
    Private Sub txtSearch_TextChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles txtSearch.TextChanged

        Dim pnl As Panel = SearchPanelCtrl()

        'Searching the Button Control and Selecting it using Search Box's Text
        For Each tlpCtrl As Control In pnl.Controls
            If tlpCtrl.Name = "tlpControl" Then
                For Each dynButton As Button In tlpCtrl.Controls
                    If Not (txtSearch.Text.Trim() = String.Empty) Then
                        If dynButton.Text = txtSearch.Text.Trim() Then
                            dynButton.Select()
                            txtSearch.Focus()
                        End If
                    End If
                Next
            End If
        Next
    End Sub

    ''' <summary>
    ''' Function Handles Button Close Click Event
    ''' </summary>
    ''' <param name="sender"></param>
    ''' <param name="e"></param>
    ''' <remarks></remarks>
    Private Sub btnClose_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnClose.Click
        Me.DialogResult = Windows.Forms.DialogResult.OK
        Me.Close()
    End Sub

    ''' <summary>
    ''' Function Handles Button Back Click Event
    ''' </summary>
    ''' <param name="sender"></param>
    ''' <param name="e"></param>
    ''' <remarks></remarks>
    Private Sub btnBack_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnBack.Click

        'Clear the Search Textbox
        txtSearch.Clear()

        'Removing Panel
        Dim removePanel As Panel = SearchPanelCtrl()
        Dim removedPanelName As String = removePanel.Name
        pnlMain.Controls.Remove(removePanel)

        If removedPanelName = "pnlItem" Then

            txtSearch.AutoCompleteCustomSource = CategorySearchList

            lblItemType.Text = SetFooterLabelText()
            lblFooter.Text = "Category List"

            Dim pnlCategory As Panel = SearchPanelCtrl()
            pnlCategory.Show()

        ElseIf removedPanelName = "pnlCategory" Then

            txtSearch.AutoCompleteCustomSource = DepartmentSearchList

            lblItemType.Text = String.Empty
            lblFooter.Text = "Department List"

            Dim pnlDepartment As Panel = SearchPanelCtrl()
            pnlDepartment.Show()
            btnBack.Visible = False
            btnHome.Visible = False

        End If

        'Re-Assigning the Search TextBox with Controls Names
        txtSearch.AutoCompleteMode = AutoCompleteMode.Suggest
        txtSearch.AutoCompleteSource = AutoCompleteSource.CustomSource

        lblQuantity.Visible = False
        nudQuantity.Visible = False

    End Sub

    ''' <summary>
    ''' Function Handles Button Home Click Ebent
    ''' </summary>
    ''' <param name="sender"></param>
    ''' <param name="e"></param>
    ''' <remarks></remarks>
    Private Sub btnHome_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnHome.Click

        'Clear Search Text Box
        txtSearch.Clear()
        txtSearch.Focus()

        Dim removePanel As Panel = SearchPanelCtrl()
        Dim removedPanelName As String = removePanel.Name

        If removedPanelName = "pnlItem" Then

            txtSearch.AutoCompleteCustomSource = DepartmentSearchList

            pnlMain.Controls.Remove(removePanel)

            Dim pnlCategory As Panel = SearchPanelCtrl()
            pnlMain.Controls.Remove(pnlCategory)
            Dim pnlDepartment As Panel = SearchPanelCtrl()
            pnlDepartment.Show()

            lblItemType.Text = String.Empty
            lblFooter.Text = "Department List"

            btnBack.Visible = False
            btnHome.Visible = False

        ElseIf removedPanelName = "pnlCategory" Then

            txtSearch.AutoCompleteCustomSource = DepartmentSearchList

            pnlMain.Controls.Remove(removePanel)

            lblItemType.Text = String.Empty
            lblFooter.Text = "Department List"

            Dim pnlDepartment As Panel = SearchPanelCtrl()
            pnlDepartment.Show()
            btnBack.Visible = False
            btnHome.Visible = False

        End If

        'Re-Assigning the Search TextBox with Controls Names
        txtSearch.AutoCompleteMode = AutoCompleteMode.SuggestAppend
        txtSearch.AutoCompleteSource = AutoCompleteSource.CustomSource

        btnAdd.Enabled = False
        lblQuantity.Visible = False
        nudQuantity.Visible = False

    End Sub

    ''' <summary>
    ''' Function Handles Button Search Click Event
    ''' </summary>
    ''' <param name="sender"></param>
    ''' <param name="e"></param>
    ''' <remarks></remarks>
    Private Sub btnSearch_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnSearch.Click

        Dim pnl As Panel = SearchPanelCtrl()
        Dim lblCtrl As Label = Nothing
        Dim lblText As String = String.Empty

        'Searching the Button Control and Selecting it using Search Box's Text
        For Each tlpCtrl As Control In pnl.Controls
            If tlpCtrl.Name = "tlpControl" Then
                For Each dynButton As Button In tlpCtrl.Controls

                    For Each ctrl As Control In dynButton.Controls
                        'If ctrl.Name = "lblButtonText" Then
                        lblCtrl = ctrl
                        lblText = lblCtrl.Text.Replace("|", "")
                        'End If
                    Next

                    If Not (txtSearch.Text.Trim() = String.Empty) Then
                        If (dynButton.Text = txtSearch.Text.ToUpper().Trim()) Or (lblText = txtSearch.Text.Trim()) Then
                            dynButton.Select()
                            If Not String.Empty = lblText Then
                                dynButton.PerformClick()
                            End If
                        End If
                    End If
                Next
            End If
        Next

    End Sub

    ''' <summary>
    ''' Function handles Button Add Click Event
    ''' </summary>
    ''' <param name="sender"></param>
    ''' <param name="e"></param>
    ''' <remarks></remarks>
    Private Sub btnAdd_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnAdd.Click

        'Dim objDbOperation As New DbOperations()
        'Dim dtItemInfo As New DataTable()

        'Dim itemLookUpCode As String = GetItemButtonLookUpCode()
        'Dim quantityPurchased As Decimal = nudQuantity.Value()

        'If Not itemLookUpCode = String.Empty Then
        '    dtItemInfo = objDbOperation.GetItemInfoByItemLookUpCode(itemLookUpCode)
        'End If

        'If Not dtItemInfo Is Nothing AndAlso dtItemInfo.Rows.Count <> 0 Then
        '    For Each dr As DataRow In dtItemInfo.Rows
        '        Dim maxTrasnEntryNumber As Integer = AddInEntry.Session.Transaction.Entries.Count + 1
        '        AddInEntry.Session.Transaction.CurrentEntryKey = maxTrasnEntryNumber
        '        AddInEntry.Session.Transaction.Entries.Add(dr("ID"), dr("ItemLookUpCode"), _
        '                                                   quantityPurchased, dr("Quantity"), 1, dr("Price"))

        '        'System.Windows.Forms.SendKeys.Send("{TAB}")
        '    Next
        'End If

        'Dim AmountValue As Double = 100.0
        'Dim QtyVal As Double = 10.0
        'Dim ItemLookUpCode As String = "44576572"
        'Dim ItemDesc As String = "Transaction Record"
        'Dim ItemId As Integer = 1111

        'Dim maxTrasnEntryNumber As Integer = AddInEntry.Session.Transaction.Entries.Count + 1

        ''       Writing to the transaction screen

        'AddInEntry.Session.Transaction.CurrentEntryKey = maxTrasnEntryNumber
        'AddInEntry.Session.Transaction.Entries.Add(ItemId, ItemDesc, 1, 0, False, AmountValue)
        'AddInEntry.Session.Transaction.Entries.Element(maxTrasnEntryNumber).SetPrice(Format(AmountValue, "0.000"), False, True)
        'AddInEntry.Session.Transaction.Entries.Element(maxTrasnEntryNumber).SetQuantityPurchased(QtyVal)
        'AddInEntry.Session.Transaction.Entries.Element(maxTrasnEntryNumber).Comment = "Testcomment"

    End Sub

End Class
#End Region