﻿#Region "File Header"
' ----------------------------------------------------------------------------------------
' File Name          :   ErrorLog.vb
' File Description   :   Write the Error and Exception information into
'                        the EventViewer and Error.txt file. 
' Date Created       :   10/26/2012
' Date Modified      :
' ----------------------------------------------------------------------------------------
#End Region

#Region "Namespaces"
Imports System.IO
Imports System.Configuration
Imports System.Windows.Forms

#End Region

#Region "ErrorLog Class"
''' <summary>
''' Class used to Log Errors
''' </summary>
''' <remarks></remarks>
Public Class ErrorLog

    ''' <summary>
    ''' To write the Error Message Informationi in the ErrorLog.txt File
    ''' </summary>
    ''' <param name="msg"></param>
    ''' <param name="stacktrace"></param>
    ''' <remarks></remarks>
    Public Shared Sub WriteTextLog(ByVal msg As String, ByVal stacktrace As String)

        Dim createFile As FileStream
        Dim openFile As FileStream
        Dim writeIntoFile As StreamWriter

        'check and make the directory if necessary; this is set to look in the
        'application folder,

        If Not System.IO.Directory.Exists("C:\Errors\") Then

            System.IO.Directory.CreateDirectory("C:\Errors\")

        End If

        'check the file
        createFile = New FileStream("C:\Errors\SmartShopping.txt", FileMode.OpenOrCreate, _
                               FileAccess.ReadWrite)
        createFile.Close()

        'log it
        openFile = New FileStream("C:\Errors\SmartShopping.txt", _
                                               FileMode.Append, FileAccess.Write)
        writeIntoFile = New StreamWriter(openFile)

        writeIntoFile.Write("================================================" _
                 & vbCrLf & vbCrLf & vbCrLf & vbCrLf)
        writeIntoFile.Write("************Message************" _
                 & vbCrLf & vbCrLf & msg & vbCrLf & vbCrLf)
        writeIntoFile.Write("************StackTrace*********" _
                 & vbCrLf & vbCrLf & stacktrace & vbCrLf & vbCrLf)
        writeIntoFile.Write("************Date/Time***********" & vbCrLf & vbCrLf _
                 & DateTime.Now.ToString() & vbCrLf & vbCrLf & vbCrLf & vbCrLf)
        writeIntoFile.Write("================================================" _
                 & vbCrLf & vbCrLf & vbCrLf & vbCrLf)

        writeIntoFile.Close()
        openFile.Close()

    End Sub


End Class
#End Region