﻿#Region "File Header"
'-----------------------------------------------------------------------
' File Name         :   Query.vb
' File Description  :   Database CRUD Operation Queries
' Date Created      :   28th September 2012
' Date Modified     :
'-----------------------------------------------------------------------
#End Region

#Region "Namespaces"
Imports System
#End Region

#Region "Query Class"
''' <summary>
''' Class used for declaring queries
''' </summary>
''' <remarks></remarks>
Public Class Query

    Public Const selectMaxEntryPOS As String = "SELECT Max(number) FROM [CustomButtons]"

    Public Const insertCustomPOS As String = "INSERT INTO CustomButtons(Number,Caption,Command,Description,Style) Values(" _
    & " '@maxNumber','Shop Now','SmartShopping.AddIn.AddInEntry','POS Button Added Items Search',7)"

    Public Const deleteCustomButtonPOS As String = "DELETE From CustomButtons WHERE Command='SmartShopping.AddIn.AddInEntry'"

    Public Const selectAllDepartment As String = "SELECT [HQID],[ID],[Name],[code],[DBTimeStamp] FROM [Department] ORDER BY [Name] ASC"

    Public Const selectAllCategories As String = "SELECT [HQID],[ID],[DepartmentID],[Name],[Code],[DBTimeStamp]" _
    & " FROM [Category] WHERE([DepartmentID] = @departmentId) ORDER BY [Name] ASC"

    Public Const selectAllItems As String = "SELECT [ID],[Description],[ItemLookupCode],[Cost],[Quantity], [DepartmentID], [CategoryID]" _
    & " FROM Item WHERE([DepartmentID] = @departmentId AND [CategoryID] = @categoryId) ORDER BY [Description] ASC"

    Public Const selectLatestItem As String = "SELECT TOP 1 I.[Description] AS Item, D.[Name] AS Department, C.[Name] AS Category FROM [Item] AS I" _
    & " JOIN [Department] AS D ON I.[DepartmentID] = D.[ID] JOIN [Category] AS C ON I.[CategoryID] = C.[ID]" _
    & " ORDER BY I.[ID] DESC"
    '& " WHERE I.[ID] = (SELECT Max([ID]) FROM [Item])"

    Public Const selectItemInfoByItemLookUpCode As String = "SELECT [ID], [ItemLookUpCode], [Quantity], [Price] FROM [Item]" _
    & " WHERE([ItemLookUpCode] = '@itemLookUpCode')"

    Public Const selectDetailItemInfoByItemId As String = "SELECT CASE WHEN S.[SupplierName] IS NULL THEN 'N\A' ELSE S.[SupplierName] END AS Supplier" _
        & " ,CASE WHEN T.[Description] IS NULL THEN 'N\A' ELSE T.[Description] END AS ItemTax" _
        & " ,I.[Price] AS Cost" _
        & " ,I.[Quantity] AS OnHandQuantity" _
        & " ,I.[ItemLookUpCode] AS Barcode" _
        & " FROM [Item] AS I" _
        & " LEFT JOIN [Supplier] AS S ON I.[SupplierID] = S.[ID]" _
        & " LEFT JOIN [Tax] AS T ON I.[TaxID] = T.[ID]" _
        & " WHERE(I.[ID] = @itemID)"

    Public Const selectItemOnHandQuantityByItemId As String = "SELECT [Quantity] AS OnHandQuantity FROM [Item] WHERE([ID] = @itemId)"

    Public Const updateDepartmentName As String = "UPDATE [Department] SET [Name] = @name WHERE(ID = @departmentId)"
    Public Const updateCategoryName As String = "UPDATE [Category] SET [Name] = @name WHERE(DepartmentID = @departmentID AND ID = @categoryId)"
    Public Const updateItemDescription As String = "UPDATE [Item] SET [Description] = @name WHERE(DepartmentID = @departmentId AND CategoryID = categoryId AND ID = @itemId)"

    Public Const createStoreImagesTable As String = "IF EXISTS (SELECT * FROM sys.objects WHERE object_id = OBJECT_ID(N'[dbo].[tblStoreImages]') AND type in (N'U'))" _
        & " BEGIN" _
        & " DROP TABLE [tblStoreImages]" _
        & " END" _
        & " CREATE TABLE [dbo].[tblStoreImages]([ImageID] [int] IDENTITY(1,1) NOT NULL, [DepartmentID] [int] NULL," _
        & " [CategoryID] [int] NULL, [ItemID] [int] NULL, [ImageName] [varchar](50) NULL," _
        & " [ImagePath] [varchar](50) NULL) "

    Public Const insertStoreImageInfo As String = "INSERT INTO [tblStoreImages]([DepartmentID]," _
        & " [CategoryID],[ItemID],[ImageName],[ImagePath])" _
        & " VALUES(@departmentId, @categoryId, @itemId, @imageName, @imagePath)"

    'Public Const selectDepartmentImage As String = "SELECT [ImagePath] FROM [tblStoreImages] WHERE(DepartmentID = @departmentId)"
    'Public Const selectCategoryImage As String = "SELECT [ImagePath] FROM [tblStoreImages]" _
    '    & " WHERE(DepartmentID = @departmentId AND CategoryID = @categoryId)"
    Public Const selectItemImage As String = "SELECT [ImagePath] FROM [tblStoreImages]" _
        & " WHERE(DepartmentID = @departmentId AND CategoryID = @categoryId AND ItemID = @itemId)"

    Public Const updateStoreImageInfo As String = "UPDATE [tblStoreImages]" _
        & " SET [ImagePath] = @imagePath" _
        & " WHERE(DepartmentID = @departmentId AND CategoryID = @categoryId AND ItemID = @itemId)"

    Public Const deleteStoreImageInfo As String = "DELETE FROM [tblStoreImages]" _
        & " WHERE(DepartmentID = @departmentId AND CategoryID = @categoryId AND ItemID = @itemId)"

End Class
#End Region