﻿#Region "File Header"
'-----------------------------------------------------------------------
' File Name         :   SettingRMS.vb
' File Description  :   1.Setting / Saving Db ConnectionString
'                       2.Adding Custom POS Button in RMS
'
' Date Created      :   28th September 2012
' Date Modified     :
'-----------------------------------------------------------------------
#End Region

#Region "Namespaces"
Imports System
Imports System.Data.SqlClient
Imports System.Windows.Forms
Imports SmartShopping.Data

#End Region

#Region "SettingRMS Class"
''' <summary>
''' Class used for Setting Up RMS AddIns
''' </summary>
''' <remarks></remarks>
Public Class SettingRMS

    ''' <summary>
    ''' Function used to test Database Connection
    ''' </summary>
    ''' <param name="connStr"></param>
    ''' <returns></returns>
    ''' <remarks></remarks>
    Public Shared Function TestDbConnection(ByVal connStr As String) As Boolean

        Try
            Using connection As New SqlConnection(connStr)
                connection.Open()
                connection.Close()
            End Using
            Return True
        Catch ex As Exception
            MessageBox.Show("Failed to Setup DataBase Connection !" & vbNewLine & ex.Message)
            Return False
        End Try

    End Function

    '''' <summary>
    '''' Function sets Application Connection String
    '''' </summary>
    '''' <param name="connStr"></param>
    '''' <remarks></remarks>
    'Public Sub SetAppConnString(ByVal connStr As String)
    '    DbOperations.SaveConnectionString(connStr)
    'End Sub

    ''' <summary>
    ''' Function Adds Custom POS Button
    ''' </summary>
    ''' <remarks></remarks>
    Public Sub CreateCustomPOS()

        If DbOperations.InsertCustomButtonDetails() Then
            MsgBox("RMS POS Operation Setup" & vbNewLine & "Successful !")
        End If
    End Sub

End Class
#End Region